// This is gifFileHeader.h
//
// Copyright 1997, 1998     Mark Manca
//


#ifndef GIFFILEHEADER_H
#define GIFFILEHEADER_H


//
// layout of additionalImageColorInfo:
// bits 0-2....max number of bits per pixel color in image.
//             we can represent 0 to 7 with these 3 bits.  The
//             0 to 7 represented maps to 1-8 bits per pixel.
// bit 3.......reserved in the GIF87a spec
// bit 4-6.....add 1 and you get # bits of color resolution.
//             Don't ask me what that is...
// bit 7.......If one, we have a global color map.  If 0, we do not.
//             If the global color map is present, it is defined
//             immediately following the header.
//

struct gifFileHeader {
	char                gifSignature[6];
	unsigned short      screenWidth;
	unsigned short      screenHeight;
	unsigned char       additionalImageColorInfo;
	unsigned char       backgroundColorIndex;
	unsigned char       placeholder;               // should be 0
};


struct gifImageHeader {
	char                imageSeparator;            // should be a ','
	unsigned short      imageLeft;
	unsigned short      imageTop;
	unsigned short      imageWidth;
	unsigned short      imageHeight;
	unsigned char       additionalImageColorInfo;
};


#endif  // GIFFILEHEADER_H
