/***************************************************************************
 *
 * File:      Matrix4f.c
 *
 * Description:  
 *
 ***************************************************************************/

#include <math.h>

#include "Matrix4f.h"

/***************************************************************************/

void
Matrix4f_mult_Vector3f(float *m, float *v, float *out)
{
#if 0
   out[0] = m[0]*v[0] + m[1]*v[1] + m[2]*v[2] + m[3];
   out[1] = m[4]*v[0] + m[5]*v[1] + m[6]*v[2] + m[7];
   out[2] = m[8]*v[0] + m[9]*v[1] + m[10]*v[2] + m[11];
#else
   out[0] = m[0]*v[0] + m[4]*v[1] + m[8]*v[2] + m[12];
   out[1] = m[1]*v[0] + m[5]*v[1] + m[9]*v[2] + m[13];
   out[2] = m[2]*v[0] + m[6]*v[1] + m[10]*v[2] + m[14];
#endif
}

void
Matrix4f_setidentity(float *m)
{
   m[0] = 1;  m[1] = 0;  m[2] = 0;  m[3] = 0;
   m[4] = 0;  m[5] = 1;  m[6] = 0;  m[7] = 0;
   m[8] = 0;  m[9] = 0;  m[10] = 1;  m[11] = 0;
   m[12] = 0;  m[13] = 0;  m[14] = 0;  m[15] = 1;
}

void
Matrix4f_set_row(float *m, int row, float *v)
{
   m[row*4] = v[0];
   m[row*4+1] = v[1];
   m[row*4+2] = v[2];
   m[row*4+3] = 1;
}

void
Matrix4f_set_col(float *m, int col, float *v)
{
   m[col] = v[0];
   m[col+4] = v[1];
   m[col+8] = v[2];
   m[col+12] = 1;
}
