#ifndef _Raytrace_h
#define _Raytrace_h

#include "Vector3f.h"
#include "SceneIO.h"

/* ray */
typedef struct _Ray
{
  Point3f P;
  Point3f D;
} Ray;

typedef struct _RTParameters
{
	float rayeps;      /* epsilon value for ray intersections */
	float minweight;   /* minimum weight to keep tracing a ray */
	int   maxlevel;    /* maximum number of tracing levels */
} RTParameters;

struct IsectType;

/* function prototypes */
void TraceRay (SceneIO *scene, int level, float weight, Ray *ray, Vector3f color,
			   RTParameters* g_params);

void Shade(SceneIO *scene, int level, float weight, Vector3f P, Vector3f N, Vector3f I,
	   struct IsectType *intersect, Vector3f color, RTParameters* g_params);
void ShadeBackground (Ray *ray, Vector3f color);


#endif



